CF1454F Array Partition 题解

题目链接:CF 或者 洛谷

感觉很多人写太复杂了,其实感觉这题性质很好的。。询问是否可以分为三段 \(max_1=min_2=max_3\)。考虑枚举 \(max_1\),由于后缀 \(max_3\) 具有单调性,所以我们可以双指针轻松拿到这样一个模型:

因为后缀 \(max\) 具有单调性,通过双指针我们可以拿到 \(j\) 后缀 \(max\) 恰好等于 \(i\) 前缀 \(max\)\(pre_j\) 后缀 \(max\) 恰好不等于,即大于 \(i\) 前缀 \(max\)。我们为了 \(pre_j\) 的双指针循环终止,可以考虑在 \(0\) 处放一个 \(INF\) 表示无穷大。那么在 \((pre_j,j]\) 任取一个点作为后缀 \(max\) 的起点都是可以满足前后缀 \(max\) 相等,接下来显然中间一段起点为 \(i+1\),终点为后缀起点的前一个位置,不妨设后缀起点假如为 \(t\),则中间一段为 \([i+1,t-1]\)。考虑可以用 ST 表维护查询区间最小值,我们观察到左端点是固定的 \(i+1\),而 \(t \in (pre_j,j]\),又想到区间 \(min\) 具有单调性,那么我们使用二分找右端点是否使得存在这个 \(min\) 就行。当然二分的右端点的下界显然不能小于 \(i+1\),取个 \(max\) 就行。注意到 \(l>r\)\(i+1>j-1\),因为 \(pre_j\) 不可能大于 \(j-1\)

即为这种情形时,注意下题目问的,这三段是显然不能挨着的:

这个时候直接判 \(NO\) 即可。二分出的 \(ans\) 注意是中间段右端点最后输出三段长即可。

参照代码
#include <bits/stdc++.h>

// #pragma GCC optimize(2)
// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")

// #define isPbdsFile

#ifdef isPbdsFile

#include <bits/extc++.h>

#else

#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/hash_policy.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/trie_policy.hpp>
#include <ext/pb_ds/tag_and_trait.hpp>
#include <ext/pb_ds/hash_policy.hpp>
#include <ext/pb_ds/list_update_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/exception.hpp>
#include <ext/rope>

#endif

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef tuple<int, int, int> tii;
typedef tuple<ll, ll, ll> tll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef __int128 i128;
#define hash1 unordered_map
#define hash2 gp_hash_table
#define hash3 cc_hash_table
#define stdHeap std::priority_queue
#define pbdsHeap __gnu_pbds::priority_queue
#define sortArr(a, n) sort(a+1,a+n+1)
#define all(v) v.begin(),v.end()
#define yes cout<<"YES"
#define no cout<<"NO"
#define Spider ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define MyFile freopen("..\\input.txt", "r", stdin),freopen("..\\output.txt", "w", stdout);
#define forn(i, a, b) for(int i = a; i <= b; i++)
#define forv(i, a, b) for(int i=a;i>=b;i--)
#define ls(x) (x<<1)
#define rs(x) (x<<1|1)
#define endl '\n'
//用于Miller-Rabin
[[maybe_unused]] static int Prime_Number[13] = {0, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37};

template <typename T>
int disc(T* a, int n)
{
    return unique(a + 1, a + n + 1) - (a + 1);
}

template <typename T>
T lowBit(T x)
{
    return x & -x;
}

template <typename T>
T Rand(T l, T r)
{
    static mt19937 Rand(time(nullptr));
    uniform_int_distribution<T> dis(l, r);
    return dis(Rand);
}

template <typename T1, typename T2>
T1 modt(T1 a, T2 b)
{
    return (a % b + b) % b;
}

template <typename T1, typename T2, typename T3>
T1 qPow(T1 a, T2 b, T3 c)
{
    a %= c;
    T1 ans = 1;
    for (; b; b >>= 1, (a *= a) %= c)if (b & 1)(ans *= a) %= c;
    return modt(ans, c);
}

template <typename T>
void read(T& x)
{
    x = 0;
    T sign = 1;
    char ch = getchar();
    while (!isdigit(ch))
    {
        if (ch == '-')sign = -1;
        ch = getchar();
    }
    while (isdigit(ch))
    {
        x = (x << 3) + (x << 1) + (ch ^ 48);
        ch = getchar();
    }
    x *= sign;
}

template <typename T, typename... U>
void read(T& x, U&... y)
{
    read(x);
    read(y...);
}

template <typename T>
void write(T x)
{
    if (typeid(x) == typeid(char))return;
    if (x < 0)x = -x, putchar('-');
    if (x > 9)write(x / 10);
    putchar(x % 10 ^ 48);
}

template <typename C, typename T, typename... U>
void write(C c, T x, U... y)
{
    write(x), putchar(c);
    write(c, y...);
}


template <typename T11, typename T22, typename T33>
struct T3
{
    T11 one;
    T22 tow;
    T33 three;

    bool operator<(const T3 other) const
    {
        if (one == other.one)
        {
            if (tow == other.tow)return three < other.three;
            return tow < other.tow;
        }
        return one < other.one;
    }

    T3() { one = tow = three = 0; }

    T3(T11 one, T22 tow, T33 three) : one(one), tow(tow), three(three)
    {
    }
};

template <typename T1, typename T2>
void uMax(T1& x, T2 y)
{
    if (x < y)x = y;
}

template <typename T1, typename T2>
void uMin(T1& x, T2 y)
{
    if (x > y)x = y;
}

constexpr int N = 2e5 + 10;
constexpr int T = 25;
int st[N][T + 1];
int a[N];
int LOG2[N];
int n;

inline void init()
{
    const int k = LOG2[n] + 1;
    forn(i, 1, n)st[i][0] = a[i];
    forn(j, 1, k)
    {
        forn(i, 1, n-(1<<j)+1)st[i][j] = min(st[i][j - 1], st[i + (1 << j - 1)][j - 1]);
    }
}

inline int query(const int l, const int r)
{
    const int k = LOG2[r - l + 1];
    return min(st[l][k], st[r - (1 << k) + 1][k]);
}

constexpr int INF = 1e9 + 7;

inline void solve()
{
    cin >> n;
    forn(i, 1, n)cin >> a[i];
    init();
    int i = 1, j = n, pre_j = n;
    int pre = a[1], nxt = a[n], nxtMax = a[n];
    while (i < j)
    {
        while (nxt < pre and j > i)uMax(nxt, a[--j]); //第一个满足
        while (nxtMax <= pre and pre_j > 0)uMax(nxtMax, a[--pre_j]); //第一个不满足
        if (nxt == pre)
        {
            int l = max(i + 1, pre_j), r = j - 1;
            if (l > r)
            {
                no << endl;
                return;
            }
            while (l < r)
            {
                const int mid = l + r + 1 >> 1;
                if (query(i + 1, mid) >= pre)l = mid;
                else r = mid - 1;
            }
            if (query(i + 1, r) == pre)
            {
                yes << endl;
                cout << i << " " << r - i << " " << n - r << endl;
                return;
            }
        }
        uMax(pre, a[++i]);
    }
    no << endl;
}

signed int main()
{
    // MyFile
    Spider
    //------------------------------------------------------
    // clock_t start = clock();
    int test = 1;
    //    read(test);
    cin >> test;
    a[0] = INF;
    forn(i, 2, N-1)LOG2[i] = LOG2[i >> 1] + 1;
    forn(i, 1, test)solve();
    //    while (cin >> n, n)solve();
    //    while (cin >> test)solve();
    // clock_t end = clock();
    // cerr << "time = " << double(end - start) / CLOCKS_PER_SEC << "s" << endl;
}


\[单个\ test\ 时间复杂度为:\ O(n\log{n}) \]

复杂度分析:

三个指针至多各自走 \(n\) 次,所以指针的移动是 \(O(n)\) 的。考虑执行的二分次数,每次 \(i+1\) 作为左端点至多执行一次二分,至多 \(n-1\) 次,预处理 \(ST\) 表是 \(n\log{n}\),单次询问则为 \(O(1)\),最终单个测试总复杂度即为 \(O(n\log{n})\)

posted @ 2024-02-03 18:28  Athanasy  阅读(16)  评论(0编辑  收藏  举报